/*
  Original Author and license?
  heavily altered to make it as much as possible platform independent:
  (c) 2003 Peter.Sieg@gmx.de, Rabishauerstr.9, 37603 Holzminden
  Code released under GNU Public License Version 2 or higher.
*/
/*Flags*/
#define NEGATIVE 128
#define OVERFLOW 64
#define BREAK    16
#define DECIMAL  8
#define INT      4
#define ZERO     2
#define CARRY    1

unsigned short address;

/*BRK////////////////*/
void BRK(void)
{
	if(curr_cycle==1)
	{
		flags|=(BREAK+INT);
		Poke(stack_ptr--,(curr_loc+2)>>8);
		Poke(stack_ptr--,(curr_loc+2)&255);
		Poke(stack_ptr--,flags);
		curr_loc=Deek(0xFFFE);/*Peek(0xFFFE)+(Peek(0xFFFF)<<8);*/
	}
	if(curr_cycle++==6)	curr_inst=0;
}

/*ORA////////////////*/
void setflags(unsigned char result)
{
	if(result&0x80)flags|=NEGATIVE;else flags&=(255-NEGATIVE);
	if(!result)flags|=ZERO;else flags&=(255-ZERO);
}
void ORA(unsigned char m)
{
	a_reg|=m;
	setflags(a_reg);
}
unsigned char IndX(void)
{
	address=(unsigned short)((unsigned char)(inst_buf[1]+x_reg));
	address=Peek(address)+(256*Peek(address+1));
	gen1=Peek(address);
	curr_loc+=2;
	return(gen1);
}
unsigned char Zero(void)
{
	address=(unsigned short)inst_buf[1];
	gen1=Peek(address);
	curr_loc+=2;
	return(gen1);
}
unsigned char Imm(void)
{
	curr_loc+=2;
	return(inst_buf[1]);
}
unsigned char Abs(void)
{
	address=(unsigned short)inst_buf[1]+((unsigned short)inst_buf[2]<<8);
	gen1=Peek(address);
	curr_loc+=3;
	return(gen1);
}
unsigned char Ind_Y(void)
{
	address=(unsigned short)inst_buf[1];
	address=Deek(address)+(unsigned short)y_reg;
	gen1=Peek(address);
	curr_loc+=2;
	return(gen1);
}
unsigned char Zero_X(void)
{
	address=(unsigned short)((unsigned char)(inst_buf[1]+x_reg));
	gen1=Peek(address);
	curr_loc+=2;
	return(gen1);
}
unsigned char Zero_Y(void)
{
	address=(unsigned short)((unsigned char)(inst_buf[1]+y_reg));
	gen1=Peek(address);
	curr_loc+=2;
	return(gen1);
}
unsigned char Abs_Y(void)
{
	address=((unsigned short)inst_buf[1]+((unsigned 
short)inst_buf[2]<<8))+y_reg;
	gen1=Peek(address);
	curr_loc+=3;
	return(gen1);
}
unsigned char Abs_X(void)
{
	address=((unsigned short)inst_buf[1]+((unsigned 
short)inst_buf[2]<<8))+x_reg;
	gen1=Peek(address);
	curr_loc+=3;
	return(gen1);
}
void ORA_IndX(void)
{
	if(curr_cycle==1)ORA(IndX());
	if(curr_cycle++==5)curr_inst=0;
}
void ORA_Zero(void)
{
	if(curr_cycle==1)ORA(Zero());
	if(curr_cycle++==2)curr_inst=0;
}
void ORA_Imm(void)
{
	ORA(Imm());
	curr_inst=0;
}
void ORA_Abs(void)
{
	if(curr_cycle==1)ORA(Abs());
	if(curr_cycle++==3)curr_inst=0;
}
void ORA_Ind_Y(void)
{
	if(curr_cycle==1)ORA(Ind_Y());
	if(curr_cycle++==4)curr_inst=0;
}
void ORA_Zero_X(void)
{
	if(curr_cycle==1)ORA(Zero_X());
	if(curr_cycle++==3)curr_inst=0;
}
void ORA_Abs_Y(void)
{
	if(curr_cycle==1)ORA(Abs_Y());
	if(((address-y_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}
void ORA_Abs_X(void)
{
	if(curr_cycle==1)ORA(Abs_X());
	if(((address-x_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}

/*ASL//////////////////////*/

unsigned char ASL(unsigned char m)
{
	if(m&0x80)flags|=CARRY;else flags&=(255-CARRY);
	m<<=1;
	setflags(m);
	return(m);
}
void Write(unsigned char result)
{
	Poke(address,result);
}
void ASL_Zero(void)
{
	if(curr_cycle==1)Write(ASL(Zero()));
	if(curr_cycle++==4)curr_inst=0;
}
void ASL_Acc(void)
{
	a_reg=ASL(a_reg);
	curr_inst=0;curr_loc++;
}
void ASL_Abs(void)
{
	if(curr_cycle==1)Write(ASL(Abs()));
	if(curr_cycle++==5)curr_inst=0;
}
void ASL_Zero_X(void)
{
	if(curr_cycle++==1)Write(ASL(Zero_X()));
	if(curr_cycle==5)curr_inst=0;
}
void ASL_Abs_X(void)
{
	if(curr_cycle++==1)Write(ASL(Abs_X()));
	if(curr_cycle==6)curr_inst=0;
}

/*PHP//////////////////////*/
void PHP(void)
{
	if(curr_cycle==1){Poke(stack_ptr--,flags);curr_loc+=1;}
	if(curr_cycle++==2)curr_inst=0;
}

/*BPL//////////////////////*/
void BPL(void)
{
	if(curr_cycle==1)curr_loc+=2;
	if((flags&NEGATIVE)==0)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else {curr_inst=0;}
}

/*CLC///////////////////////*/
void CLC(void)
{
	flags&=(255-CARRY);
	curr_inst=0;
	curr_loc++;
}

/*JSR///////////////////////*/
void JSR(void)
{
	/* ???? */
	curr_loc+=2;
	Poke(stack_ptr--,curr_loc>>8);Poke(stack_ptr--,curr_loc&255);
	curr_loc=(unsigned short)inst_buf[1]+((unsigned short)inst_buf[2]<<8);
	curr_inst=0;
}

/*AND///////////////////////*/
void AND(unsigned char m)
{
	a_reg&=m;
	setflags(a_reg);
}
void AND_IndX(void)
{
	if(curr_cycle==1)AND(IndX());
	if(curr_cycle++==5)curr_inst=0;
}
void AND_Zero(void)
{
	if(curr_cycle==1)AND(Zero());
	if(curr_cycle++==2)curr_inst=0;
}
void AND_Imm(void)
{
	AND(Imm());
	curr_inst=0;
}
void AND_Abs(void)
{
	if(curr_cycle==1)AND(Abs());
	if(curr_cycle++==3)curr_inst=0;
}
void AND_Ind_Y(void)
{
	if(curr_cycle==1)AND(Ind_Y());
	if(curr_cycle++==4)curr_inst=0;
}
void AND_Zero_X(void)
{
	if(curr_cycle==1)AND(Zero_X());
	if(curr_cycle++==3)curr_inst=0;
}
void AND_Abs_Y(void)
{
	if(curr_cycle==1)AND(Abs_Y());
	if(((address-y_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}
void AND_Abs_X(void)
{
	if(curr_cycle==1)AND(Abs_X());
	if(((address-x_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}

/*BIT////////////////////////*/
void BIT(unsigned char m)
{
	setflags(a_reg&m);
	if(m&0x80)flags|=NEGATIVE;else flags&=(255-NEGATIVE);
	if(m&0x40)flags|=OVERFLOW;else flags&=(255-OVERFLOW);
}
void BIT_Zero(void)
{
	if(curr_cycle==1)BIT(Zero());
	if(curr_cycle++==2)curr_inst=0;
}
void BIT_Abs(void)
{
	if(curr_cycle==1)BIT(Abs());
	if(curr_cycle++==3)curr_inst=0;
}

/*ROL////////////////////////*/
unsigned char ROL(unsigned char m)
{
	if(flags&CARRY)gen1=0xff;else gen1=0;
	m=ASL(m);
	if(gen1)m|=1;
	setflags(m);
	return(m);
}
void ROL_Zero(void)
{
	if(curr_cycle==1)Write(ROL(Zero()));
	if(curr_cycle++==4)curr_inst=0;
}
void ROL_Acc(void)
{
	a_reg=ROL(a_reg);
	curr_inst=0;curr_loc++;
}
void ROL_Abs(void)
{
	if(curr_cycle==1)Write(ROL(Abs()));
	if(curr_cycle++==5)curr_inst=0;
}
void ROL_Zero_X(void)
{
	if(curr_cycle++==1)Write(ROL(Zero_X()));
	if(curr_cycle==5)curr_inst=0;
}
void ROL_Abs_X(void)
{
	if(curr_cycle++==1)Write(ROL(Abs_X()));
	if(curr_cycle==6)curr_inst=0;
}

/*PLP////////////////////////*/
void PLP(void)
{
	if(curr_cycle==1)
	{
		flags=Peek(++stack_ptr);
	}
	if(curr_cycle++==3)
	{
		curr_inst=0;curr_loc+=1;
	}
}

/*BMI////////////////////////*/
void BMI(void)
{
	if(curr_cycle==1)curr_loc+=2;
	if(flags&NEGATIVE)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else{curr_inst=0;}
}

/*SEC////////////////////////*/
void SEC(void)
{
	flags|=CARRY;
	curr_inst=0;
	curr_loc++;
}

/*RTI////////////////////////*/
void RTI(void)
{
	if(curr_cycle==1)
	{
		flags=Peek(++stack_ptr);
		curr_loc=Deek(++stack_ptr);
        stack_ptr++;
	}
	if(curr_cycle++==5) curr_inst=0;
}

/*EOR////////////////////////*/
void EOR(unsigned char m)
{
	a_reg^=m;
	setflags(a_reg);
}
void EOR_IndX(void)
{
	if(curr_cycle==1)EOR(IndX());
	if(curr_cycle++==5)curr_inst=0;
}
void EOR_Zero(void)
{
	if(curr_cycle==1)EOR(Zero());
	if(curr_cycle++==2)curr_inst=0;
}
void EOR_Imm(void)
{
	EOR(Imm());
	curr_inst=0;
}
void EOR_Abs(void)
{
	if(curr_cycle==1)EOR(Abs());
	if(curr_cycle++==3)curr_inst=0;
}
void EOR_Ind_Y(void)
{
	if(curr_cycle==1)EOR(Ind_Y());
	if(curr_cycle++==4)curr_inst=0;
}
void EOR_Zero_X(void)
{
	if(curr_cycle==1)EOR(Zero_X());
	if(curr_cycle++==3)curr_inst=0;
}
void EOR_Abs_Y(void)
{
	if(curr_cycle==1)EOR(Abs_Y());
	if(((address-y_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}
void EOR_Abs_X(void)
{
	if(curr_cycle==1)EOR(Abs_X());
	if(((address-x_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}

/*LSR//////////////////////*/
unsigned char LSR(unsigned char m)
{
	if(m&1)flags|=CARRY;else flags&=(255-CARRY);
	m>>=1;
	setflags(m);
	return(m);
}
void LSR_Zero(void)
{
	if(curr_cycle==1)Write(LSR(Zero()));
	if(curr_cycle++==4)curr_inst=0;
}
void LSR_Acc(void)
{
	a_reg=LSR(a_reg);
	curr_inst=0;curr_loc++;
}
void LSR_Abs(void)
{
	if(curr_cycle==1)Write(LSR(Abs()));
	if(curr_cycle++==5)curr_inst=0;
}
void LSR_Zero_X(void)
{
	if(curr_cycle++==1)Write(LSR(Zero_X()));
	if(curr_cycle==5)curr_inst=0;
}
void LSR_Abs_X(void)
{
	if(curr_cycle++==1)Write(LSR(Abs_X()));
	if(curr_cycle==6)curr_inst=0;
}

/*PHA//////////////////////*/
void PHA(void)
{
	if(curr_cycle==1)
	{
		Poke(stack_ptr--,a_reg);
		curr_loc++;
	}
	if(curr_cycle++==2)
	{
		curr_inst=0;
	}
}

/*JMP//////////////////////*/
void JMP_Abs(void)
{
	if(curr_cycle==1)
		curr_loc=(unsigned short)inst_buf[1]+((unsigned 
short)inst_buf[2]<<8);
	if(curr_cycle++==2)	curr_inst=0;
}
void JMP_Ind(void)
{
	if(curr_cycle==1)
	{
		address=(unsigned short)inst_buf[1]+((unsigned 
short)inst_buf[2]<<8);
		curr_loc=Deek(address);
	}
	if(curr_cycle++==4) curr_inst=0;
}

/*BVC/////////////////////*/
void BVC(void)
{
	if(curr_cycle==1)curr_loc+=2;
	if((flags&OVERFLOW)==0)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else {curr_inst=0;}
}

/*CLI//////////////////////*/
void CLI(void)
{
	flags&=(255-INT);
	curr_loc++;
	curr_inst=0;
}

/*RTS//////////////////////*/
void RTS(void)
{
	if(curr_cycle==1)
	{
		curr_loc=1+(Deek(++stack_ptr));stack_ptr++;
	}
	if(curr_cycle++==5) curr_inst=0;
}

/*ADC//////////////////////*/
void ADC(unsigned char m)
{
	/*if(!flags&DECIMAL)*/
	/*{*/
		int carry=0;
		gen1=a_reg;
		if(flags&CARRY)carry=1;
		if((a_reg+=m+carry)!=((unsigned short)a_reg+(unsigned 
short)m+carry))
			flags|=CARRY;
		else flags&=(255-CARRY);
		setflags(a_reg);
		if((a_reg>=0x80)&(gen1<0x80)&(m<0x80))
			flags|=OVERFLOW;
		else flags&=(255-OVERFLOW);
	/*}*/
	/*else*/
	/*{*/
		/*?????*/
	/*}*/
}
void ADC_IndX(void)
{
	if(curr_cycle==1)ADC(IndX());
	if(curr_cycle++==5)curr_inst=0;
}
void ADC_Zero(void)
{
	if(curr_cycle==1)ADC(Zero());
	if(curr_cycle++==2)curr_inst=0;
}
void ADC_Imm(void)
{
	ADC(Imm());
	curr_inst=0;
}
void ADC_Abs(void)
{
	if(curr_cycle==1)ADC(Abs());
	if(curr_cycle++==3)curr_inst=0;
}
void ADC_Ind_Y(void)
{
	if(curr_cycle==1)ADC(Ind_Y());
	if(curr_cycle++==4)curr_inst=0;
}
void ADC_Zero_X(void)
{
	if(curr_cycle==1)ADC(Zero_X());
	if(curr_cycle++==3)curr_inst=0;
}
void ADC_Abs_Y(void)
{
	if(curr_cycle==1)ADC(Abs_Y());
	if(((address-y_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}
void ADC_Abs_X(void)
{
	if(curr_cycle==1)ADC(Abs_X());
	if(((address-x_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}

/*ROR////////////////////////*/
unsigned char ROR(unsigned char m)
{
	if(flags&CARRY)gen1=0xff;else gen1=0;
	m=LSR(m);
	if(gen1)m|=0x80;
	setflags(m);
	return(m);
}
void ROR_Zero(void)
{
	if(curr_cycle==1)Write(ROR(Zero()));
	if(curr_cycle++==4)curr_inst=0;
}
void ROR_Acc(void)
{
	a_reg=ROR(a_reg);
	curr_inst=0;curr_loc++;
}
void ROR_Abs(void)
{
	if(curr_cycle==1)Write(ROR(Abs()));
	if(curr_cycle++==5)curr_inst=0;
}
void ROR_Zero_X(void)
{
	if(curr_cycle++==1)Write(ROR(Zero_X()));
	if(curr_cycle==5)curr_inst=0;
}
void ROR_Abs_X(void)
{
	if(curr_cycle++==1)Write(ROR(Abs_X()));
	if(curr_cycle==6)curr_inst=0;
}

/*PLA///////////////////////*/
void PLA(void)
{
	if(curr_cycle==1)
	{
		a_reg=Peek(++stack_ptr);
		setflags(a_reg);
	}
	if(curr_cycle++==3)
	{
		curr_inst=0;curr_loc+=1;
	}
}

/*BVS///////////////////////*/
void BVS(void)
{
	if(curr_cycle==1)curr_loc+=2;
	if(flags&OVERFLOW)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else {curr_inst=0;}
}

/*SEI///////////////////////*/
void SEI(void)
{
	flags|=INT;
	curr_loc++;
	curr_inst=0;
}

/*STA///////////////////////*/
void STA_IndX(void)
{
	if(curr_cycle==1)
	{
		IndX();
		Write(a_reg);
	}
	if(curr_cycle++==5) curr_inst=0;
}
void STA_Zero(void)
{
	if(curr_cycle==1)
	{
		Zero();
		Write(a_reg);
	}
	if(curr_cycle++==2) curr_inst=0;
}
void STA_Abs(void)
{
	if(curr_cycle==1)
	{
		Abs();
		Write(a_reg);
	}
	if(curr_cycle++==3) curr_inst=0;
}
void STA_Ind_Y(void)
{
	if(curr_cycle==1)
	{
		Ind_Y();
		Write(a_reg);
	}
	if(curr_cycle++==5) curr_inst=0;
}
void STA_Zero_X(void)
{
	if(curr_cycle==1)
	{
		Zero_X();
		Write(a_reg);
	}
	if(curr_cycle++==3) curr_inst=0;
}
void STA_Abs_Y(void)
{
	if(curr_cycle==1)
	{
		Abs_Y();
		Write(a_reg);
	}
	if(curr_cycle++==4) curr_inst=0;
}
void STA_Abs_X(void)
{
	if(curr_cycle==1)
	{
		Abs_X();
		Write(a_reg);
	}
	if(curr_cycle++==4) curr_inst=0;
}

/*STY//////////////////////*/
void STY_Zero(void)
{
	if(curr_cycle==1)
	{
		Zero();
		Write(y_reg);
	}
	if(curr_cycle++==2) curr_inst=0;
}
void STY_Abs(void)
{
	if(curr_cycle==1)
	{
		Abs();
		Write(y_reg);
	}
	if(curr_cycle++==3) curr_inst=0;
}
void STY_Zero_X(void)
{
	if(curr_cycle==1)
	{
		Zero_X();
		Write(y_reg);
	}
	if(curr_cycle++==3) curr_inst=0;
}

/*STX//////////////////////*/
void STX_Zero(void)
{
	if(curr_cycle==1)
	{
		Zero();
		Write(x_reg);
	}
	if(curr_cycle++==2) curr_inst=0;
}
void STX_Abs(void)
{
	if(curr_cycle==1)
	{
		Abs();
		Write(x_reg);
	}
	if(curr_cycle++==3) curr_inst=0;
}
void STX_Zero_Y(void)
{
	if(curr_cycle==1)
	{
		Zero_Y();
		Write(x_reg);
	}
	if(curr_cycle++==3) curr_inst=0;
}

/*DEY//////////////////////*/
void DEY(void)
{
	y_reg--;
	setflags(y_reg);
	curr_loc++;
	curr_inst=0;
}

/*TXA//////////////////////*/
void TXA(void)
{
	a_reg=x_reg;
	setflags(a_reg);
	curr_loc++;
	curr_inst=0;
}

/*BCC//////////////////////*/
void BCC(void)
{
    if(curr_cycle==1)curr_loc+=2;
	if((flags&CARRY)==0)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else {curr_inst=0;}
}

/*TYA//////////////////////*/
void TYA(void)
{
	a_reg=y_reg;
	setflags(a_reg);
	curr_loc++;
	curr_inst=0;
}

/*TXS//////////////////////*/
void TXS(void)
{
	stack_ptr=x_reg+0x100;
	curr_loc++;
	curr_inst=0;
}

/*LDY//////////////////////*/
void LDY_Imm(void)
{
	y_reg=Imm();
	setflags(y_reg);
	curr_inst=0;
}
void LDY_Zero(void)
{
	if(curr_cycle==1)
	{
		y_reg=Zero();
		setflags(y_reg);
	}
	if(curr_cycle++==2)
		curr_inst=0;
}
void LDY_Abs(void)
{
	if(curr_cycle==1)
	{
		y_reg=Abs();
		setflags(y_reg);
	}
	if(curr_cycle++==3)
		curr_inst=0;
}
void LDY_Zero_X(void)
{
	if(curr_cycle==1)
	{
		y_reg=Zero_X();
		setflags(y_reg);
	}
	if(curr_cycle++==3)
		curr_inst=0;
}
void LDY_Abs_X(void)
{
	if(curr_cycle==1)
	{
		y_reg=Abs_X();
		setflags(y_reg);
	}
	if(((address-x_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==5) curr_inst=0;
	}
	else if(curr_cycle++==4) curr_inst=0;
}

/*LDA///////////////////////*/
void LDA_IndX(void)
{
	if(curr_cycle==1)
	{
		a_reg=IndX();
		setflags(a_reg);
	}
	if(curr_cycle++==5)
		curr_inst=0;
}
void LDA_Imm(void)
{
	a_reg=Imm();
	setflags(a_reg);
	curr_inst=0;
}
void LDA_Zero(void)
{
	if(curr_cycle==1)
	{
		a_reg=Zero();
		setflags(a_reg);
	}
	if(curr_cycle++==2)
		curr_inst=0;
}
void LDA_Abs(void)
{
	if(curr_cycle==1)
	{
		a_reg=Abs();
		setflags(a_reg);
	}
	if(curr_cycle++==3)
		curr_inst=0;
}
void LDA_Zero_X(void)
{
	if(curr_cycle==1)
	{
		a_reg=Zero_X();
		setflags(a_reg);
	}
	if(curr_cycle++==3)
		curr_inst=0;
}
void LDA_Ind_Y(void)
{
	if(curr_cycle==1)
	{
		a_reg=Ind_Y();
		setflags(a_reg);
	}
	if(((address-y_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==5) curr_inst=0;
	}
	else if(curr_cycle++==4) curr_inst=0;
}

void LDA_Abs_X(void)
{
	if(curr_cycle==1)
	{
		a_reg=Abs_X();
		setflags(a_reg);
	}
	if(((address-x_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==5) curr_inst=0;
	}
	else if(curr_cycle++==4) curr_inst=0;
}
void LDA_Abs_Y(void)
{
	if(curr_cycle==1)
	{
		a_reg=Abs_Y();
		setflags(a_reg);
	}
	if(((address-y_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==5) curr_inst=0;
	}
	else if(curr_cycle++==4) curr_inst=0;
}

/*LDX//////////////////////*/
void LDX_Imm(void)
{
	x_reg=Imm();
	setflags(x_reg);
	curr_inst=0;
}
void LDX_Zero(void)
{
	if(curr_cycle==1)
	{
		x_reg=Zero();
		setflags(x_reg);
	}
	if(curr_cycle++==2)
		curr_inst=0;
}
void LDX_Abs(void)
{
	if(curr_cycle==1)
	{
		x_reg=Abs();
		setflags(x_reg);
	}
	if(curr_cycle++==3)
		curr_inst=0;
}
void LDX_Zero_Y(void)
{
	if(curr_cycle==1)
	{
		x_reg=Zero_Y();
		setflags(x_reg);
	}
	if(curr_cycle++==3)
		curr_inst=0;
}
void LDX_Abs_Y(void)
{
	if(curr_cycle==1)
	{
		x_reg=Abs_Y();
		setflags(x_reg);
	}
	if(((address-y_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==5) curr_inst=0;
	}
	else if(curr_cycle++==4) curr_inst=0;
}

/*TAY//////////////////////*/
void TAY(void)
{
	y_reg=a_reg;
	setflags(y_reg);
	curr_loc++;
	curr_inst=0;
}

/*TAX//////////////////////*/
void TAX(void)
{
	x_reg=a_reg;
	setflags(x_reg);
	curr_loc++;
	curr_inst=0;
}

/*BCS//////////////////////*/
void BCS(void)
{
	if(curr_cycle==1)curr_loc+=2;
	if(flags&CARRY)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else {curr_inst=0;}
}

/*CLV//////////////////////*/
void CLV(void)
{
	flags&=(255-OVERFLOW);
	curr_loc++;
	curr_inst=0;
}

/*TSX//////////////////////*/
void TSX(void)
{
	x_reg=stack_ptr&0xff;
	setflags(x_reg);
	curr_loc++;
	curr_inst=0;
}

/*CPY//////////////////////*/
void CPY(unsigned char m)
{
	gen1=y_reg-m;
	setflags(gen1);


	if(m<=y_reg)flags|=CARRY;
		else flags&=(255-CARRY);
}
void CPY_Imm(void)
{
	CPY(Imm());
	curr_inst=0;
}
void CPY_Zero(void)
{
	if(curr_cycle==1)
		CPY(Zero());
	if(curr_cycle++==2)
		curr_inst=0;
}
void CPY_Abs(void)
{
	if(curr_cycle==1)
		CPY(Abs());
	if(curr_cycle++==3)
		curr_inst=0;
}

/*CMP//////////////////////*/
void CMP(unsigned char m)
{
	gen1=a_reg-m;
	setflags(gen1);
	if(m<=a_reg)flags|=CARRY;
		else flags&=(255-CARRY);
}
void CMP_Imm(void)
{
	CMP(Imm());
	curr_inst=0;
}
void CMP_Zero(void)
{
	if(curr_cycle==1)
		CMP(Zero());
	if(curr_cycle++==2)
		curr_inst=0;
}
void CMP_Abs(void)
{
	if(curr_cycle==1)
		CMP(Abs());
	if(curr_cycle++==3)
		curr_inst=0;
}
void CMP_IndX(void)
{
	if(curr_cycle==1)
	{
		CMP(IndX());
	}
	if(curr_cycle++==5)
		curr_inst=0;
}
void CMP_Zero_X(void)
{
	if(curr_cycle==1)
	{
		CMP(Zero_X());
	}
	if(curr_cycle++==3)
		curr_inst=0;
}
void CMP_Ind_Y(void)
{
	if(curr_cycle==1)
	{
		CMP(Ind_Y());
	}
	if(((address-y_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==5) curr_inst=0;
	}
	else if(curr_cycle++==4) curr_inst=0;
}

void CMP_Abs_X(void)
{
	if(curr_cycle==1)
	{
		CMP(Abs_X());
	}
	if(((address-x_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==4) curr_inst=0;
	}
	else if(curr_cycle++==3) curr_inst=0;
}
void CMP_Abs_Y(void)
{
	if(curr_cycle==1)
	{
		CMP(Abs_Y());
	}
	if(((address-y_reg)/256)!=(address/256))
	{
		 if(curr_cycle++==4) curr_inst=0;
	}
	else if(curr_cycle++==3) curr_inst=0;
}
/*DEC//////////////////////*/
void DEC_Zero(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Zero()-1);
		setflags(temp);
	}
	if(curr_cycle++==4) curr_inst=0;
}
void DEC_Abs(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Abs()-1);
		setflags(temp);
	}
	if(curr_cycle++==5) curr_inst=0;
}
void DEC_Zero_X(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Zero_X()-1);
		setflags(temp);
	}
	if(curr_cycle++==5) curr_inst=0;
}
void DEC_Abs_X(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Abs_X()-1);
		setflags(temp);
	}
	if(curr_cycle++==6) curr_inst=0;
}

/*INY//////////////////////*/
void INY(void)
{
	y_reg++;
	setflags(y_reg);
	curr_loc++;
	curr_inst=0;
}

/*DEX//////////////////////*/
void DEX(void)
{
	x_reg--;
	setflags(x_reg);
	curr_loc++;
	curr_inst=0;
}

/*BNE//////////////////////*/
void BNE(void)
{
	if(curr_cycle==1)curr_loc+=2;
	if((flags&ZERO)==0)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else {curr_inst=0;}
}

/*CLD////////////////////////*/
void CLD(void)
{
	flags&=(255-DECIMAL);
	curr_inst=0;
	curr_loc++;
}

/*CPX////////////////////////*/
void CPX(unsigned char m)
{
	gen1=x_reg-m;
	setflags(gen1);


	if(m<=x_reg)flags|=CARRY;
		else flags&=(255-CARRY);
}
void CPX_Imm(void)
{
	CPX(Imm());
	curr_inst=0;
}
void CPX_Zero(void)
{
	if(curr_cycle==1)
		CPX(Zero());
	if(curr_cycle++==2)
		curr_inst=0;
}
void CPX_Abs(void)
{
	if(curr_cycle==1)
		CPX(Abs());
	if(curr_cycle++==3)
		curr_inst=0;
}

/*SBC////////////////////////*/
void SBC(unsigned char m)
{
	/*if(flags&DECIMAL==0)*/
	/*{*/
		short carry=0;
		gen1=a_reg;
		if(flags&CARRY)carry=1;
		if(a_reg>=m)
			flags|=CARRY;
		else flags&=255-CARRY;
		a_reg-=m+(1-carry);
		setflags(a_reg);
		if((a_reg>=0x80)&(gen1<0x80)&(m<0x80))
			flags|=OVERFLOW;
		else flags&=(255-OVERFLOW);
	/*}*/
	/*else*/
	/*{*/
		/*?????*/
	/*}*/
}
void SBC_IndX(void)
{
	if(curr_cycle==1)SBC(IndX());
	if(curr_cycle++==5)curr_inst=0;
}
void SBC_Zero(void)
{
	if(curr_cycle==1)SBC(Zero());
	if(curr_cycle++==2)curr_inst=0;
}
void SBC_Imm(void)
{
	SBC(Imm());
	curr_inst=0;
}
void SBC_Abs(void)
{
	if(curr_cycle==1)SBC(Abs());
	if(curr_cycle++==3)curr_inst=0;
}
void SBC_Ind_Y(void)
{
	if(curr_cycle==1)SBC(Ind_Y());
	if(curr_cycle++==4)curr_inst=0;
}
void SBC_Zero_X(void)
{
	if(curr_cycle==1)SBC(Zero_X());
	if(curr_cycle++==3)curr_inst=0;
}
void SBC_Abs_Y(void)
{
	if(curr_cycle==1)SBC(Abs_Y());
	if(((address-y_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}
void SBC_Abs_X(void)
{
	if(curr_cycle==1)SBC(Abs_X());
	if(((address-x_reg)/256)==(address/256))
	{
		if(curr_cycle++==4)curr_inst=0;
	}
	else if(curr_cycle++==5)curr_inst=0;
}

/*INC///////////////////////*/
void INC_Zero(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Zero()+1);
		setflags(temp);
	}
	if(curr_cycle++==4) curr_inst=0;
}
void INC_Abs(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Abs()+1);
		setflags(temp);
	}
	if(curr_cycle++==5) curr_inst=0;
}
void INC_Zero_X(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Zero_X()+1);
		setflags(temp);
	}
	if(curr_cycle++==5) curr_inst=0;
}
void INC_Abs_X(void)
{
	unsigned char temp;
	if(curr_cycle==1)
	{
		Write(temp=Abs_X()+1);
		setflags(temp);
	}
	if(curr_cycle++==6) curr_inst=0;
}

/*INX///////////////////////*/
void INX(void)
{
	x_reg++;
	setflags(x_reg);
	curr_loc++;
	curr_inst=0;
}

/*NOP///////////////////////*/
void NOP(void)
{
	curr_loc++;
	curr_inst=0;
}

/*BEQ///////////////////////*/
void BEQ(void)
{
	if(curr_cycle==1)curr_loc+=2;
	if(flags&ZERO)
	{
		if(curr_cycle==2)
		{
			curr_loc+=(signed char)inst_buf[1];
			if((curr_loc/256)==((curr_loc+(signed char)inst_buf[1])/256));
			{
				curr_inst=0;
			}

		}
		if(curr_cycle++==3)curr_inst=0;
	}
	else {curr_inst=0;}
}

/*SED///////////////////////*/
void SED(void)
{
	flags&=DECIMAL;
	curr_inst=0;
	curr_loc++;
}

