/*
  Original Author and license?
  heavily altered to make it as much as possible platform independent:
  (c) 2003 Peter.Sieg@gmx.de, Rabishauerstr.9, 37603 Holzminden
  Code released under GNU Public License Version 2 or higher.
*/
/*#define UNIX		1*/
#ifndef UNIX
#include <dos.h>
#include <conio.h>
#include <alloc.h>
#define short int
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define DOSVIDEO      1
#ifdef UNIX
#undef DOSVIDEO
#include "unix.c"
#define farmalloc malloc
#define farfree free
#define far /**/
#endif
/*===========================================================================*/
/* compatiblity routines */
/*#define Xkbhit() kbhit()*/
/*#define Xgetch() getch()*/
#ifndef UNIX
#define Xkbhit() dos_kbhit()
#define Xgetch() dos_getch()
/*#define Xclrscr() clrscr()*/
/*#define Xgotoxy gotoxy*/
#else
#define Xkbhit() unix_kbhit()
#define Xgetch() getchar()
#endif
#define Xclrscr() ansi_clrscr()
#define Xgotoxy ansi_gotoxy

/*===========================================================================*/

unsigned char scrn_code[128]={64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
80,81,82,83,84,85,86,87,88,89,90,91,156,93,24,27,32,33,34,35,36,37,38,39,40,41,
42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,196,6,179,
196,196,196,196,179,179,170,192,88,88,88,88,88,88,88,88,88,88,88,88,88,88,88,88,
88,88,88,88,88,88,32,88,88,88,88,88,88,88,88,88,88,88,88,88,88,88,88,88,88,88,
88,88,88,88,88,88,88,88,88,88,88};
unsigned char color_map[16]={0,15,4,3,5,2,1,14,6,6,12,8,7,10,3,15};
#ifndef UNIX
union REGS reg;
#endif
unsigned char oldkeycolumn;
unsigned short IOaddress;
short IRQ=0;
char instruction_name[10];
#ifdef DOSVIDEO
  unsigned char far *vidram=(char far *)0xB8000000L;
#endif
unsigned char a_reg,x_reg,y_reg,flags,curr_inst,curr_cycle,gen1;
unsigned short  curr_loc,stack_ptr;
unsigned char inst_buf[4];
int modeset=0,allocated=0;
unsigned int cycles;
unsigned char BASICptr[8192];
unsigned char KernalPtr[8192];
unsigned char far *RAMptr;
unsigned char far *keyptr; /* ptr to RAMptr[0xdc00] */

#ifndef UNIX
short dos_kbhit()
{
#define ZF 0x40		/* zero flag */

 	reg.h.ah=1;
 	int86(0x16,&reg,&reg);
	/* if zero-flag==0 then key is waiting */
        if ((reg.x.flags & ZF) == 0) return 1;
	else return 0;
}

char dos_getch()
{
 	reg.h.ah=0;
 	int86(0x16,&reg,&reg);
	return reg.h.al;
}
#endif

void ansi_clrscr()
{
	printf("\x1B[2J\x1B[44m");
}

void ansi_gotoxy(short x, short y)
{
	printf("\x1B[%d;%dH",x,y);
}


short rawkey;

#ifdef DOSVIDEO
void SetMode(char mode)
{
/*	asm mov AH,0;
	asm mov AL, (mode);
	asm int 0x10;
*/
 	reg.h.ah=0;
 	reg.h.al=mode;
 	int86(0x10,&reg,&reg);
}
#endif

void Cleanup(void)
{
#ifdef DOSVIDEO
	if(modeset)SetMode(0x03);
#endif
	if(allocated)
	{
		farfree(RAMptr);
	}
	printf("%lu cycles\n",cycles);
	exit(0);
}

void Quit(char message[])
{
	printf("%s\nPress any key...\n",message);
	while(!Xkbhit());
	Cleanup();
}

void AllocMem(void)
{
	long index;
	if((RAMptr=(char far *)farmalloc(65536))==NULL) Quit("Error allocating 64k memory for RAM");
	printf("64k for RAM...\n");
	allocated=1;
	keyptr=RAMptr+0xdc00;
	for(index=0;index<65536;index++)
		RAMptr[index]=0;
}

void LoadROM(void)
{
	short index;
	FILE *infile;
	/* Load BASIC */
	if((infile=fopen("original.64b","rb"))==NULL) Quit("Error opening file ORIGINAL.64B");
	for(index=0;index<8192;index++)
		BASICptr[index]=fgetc(infile);

	fclose(infile);
	printf("BASIC loaded...\n");

	/* Load Kernal */
	if((infile=fopen("original.64k","rb"))==NULL) Quit("Error opening file ORIGINAL.64k");
	for(index=0;index<8192;index++)
		KernalPtr[index]=fgetc(infile);

	fclose(infile);
	printf("Kernal loaded...\n");
}
unsigned char Peek(unsigned short address)
{
	if(address>0x9FFF)
	{
		if(address<0xC000)
			return(BASICptr[address&0x1FFF]);
	}
	if(address>0xDFFF)
	{
		return(KernalPtr[address&0x1FFF]);
	}
	return(RAMptr[address]);
}

unsigned int Deek(unsigned short address)
{
	return Peek(address)+((Peek(address+1)<<8));
}

void Poke(unsigned short address, unsigned char value)
{
	RAMptr[address]=value;
}


#include"6510.c"
void _6510(void)
{
	unsigned short temp_addr;
	if(curr_inst==0)
	{
		if(IRQ)
		{
			IRQ=0;
			if(flags&INT)goto noIRQ;
			RAMptr[stack_ptr--]=curr_loc>>8;
			RAMptr[stack_ptr--]=curr_loc&255;
			RAMptr[stack_ptr--]=flags;
			curr_loc=KernalPtr[0x1FFE]+(KernalPtr[0x1FFF]<<8);
			flags|=INT;
		}
noIRQ:
		if(curr_loc>0x9FFF)
		{
			if(curr_loc<0xC000)
			{
				inst_buf[0]=BASICptr[(curr_loc+0)&0x1FFF];
				inst_buf[1]=BASICptr[(curr_loc+1)&0x1FFF];
				inst_buf[2]=BASICptr[(curr_loc+2)&0x1FFF];
				inst_buf[3]=BASICptr[(curr_loc+3)&0x1FFF];
				/**((unsigned long *)inst_buf)=*((unsigned long 
*)(BASICptr+(curr_loc&0x1FFF)));*/
				goto found;
			}
		}
		if(curr_loc>0xDFFF)
		{
			inst_buf[0]=KernalPtr[(curr_loc+0)&0x1FFF];
			inst_buf[1]=KernalPtr[(curr_loc+1)&0x1FFF];
			inst_buf[2]=KernalPtr[(curr_loc+2)&0x1FFF];
			inst_buf[3]=KernalPtr[(curr_loc+3)&0x1FFF];
			/**((unsigned long *)inst_buf)=*((unsigned long 
*)(KernalPtr+(curr_loc&0x1FFF)));*/
		}
		else
		{
			inst_buf[0]=RAMptr[(curr_loc+0)&0x1FFF];
			inst_buf[1]=RAMptr[(curr_loc+1)&0x1FFF];
			inst_buf[2]=RAMptr[(curr_loc+2)&0x1FFF];
			inst_buf[3]=RAMptr[(curr_loc+3)&0x1FFF];
			/**((unsigned long *)inst_buf)=*((unsigned long 
*)(RAMptr+curr_loc));*/
		}
found:
		curr_cycle=1;
		curr_inst=inst_buf[0];

	}/*end if(!curr_inst)*/
	else switch(curr_inst) {
		case 0x00: BRK();break;
		case 0x01: ORA_IndX();break;
		case 0x05: ORA_Zero();break;
		case 0x06: ASL_Zero();break;
		case 0x08: PHP();break;
		case 0x09: ORA_Imm();break;
		case 0x0A: ASL_Acc();break;
		case 0x0D: ORA_Abs();break;
		case 0x0E: ASL_Abs();break;
		case 0x10: BPL();break;
		case 0x11: ORA_Ind_Y();break;
		case 0x15: ORA_Zero_X();break;
		case 0x16: ASL_Zero_X();break;
		case 0x18: CLC();break;
		case 0x19: ORA_Abs_Y();break;
		case 0x1D: ORA_Abs_X();break;
		case 0x1E: ASL_Abs_X();break;
		case 0x20: JSR();break;
		case 0x21: AND_IndX();break;
		case 0x24: BIT_Zero();break;
		case 0x25: AND_Zero();break;
		case 0x26: ROL_Zero();break;
		case 0x28: PLP();break;
		case 0x29: AND_Imm();break;
		case 0x2A: ROL_Acc();break;
		case 0x2C: BIT_Abs();break;
		case 0x2D: AND_Abs();break;
		case 0x2E: ROL_Abs();break;
		case 0x30: BMI();break;
		case 0x31: AND_Ind_Y();break;
		case 0x35: AND_Zero_X();break;
		case 0x36: ROL_Zero_X();break;
		case 0x38: SEC();break;
		case 0x39: AND_Abs_Y();break;
		case 0x3D: AND_Abs_X();break;
		case 0x3E: ROL_Abs_X();break;
		case 0x40: RTI();break;
		case 0x41: EOR_IndX();break;
		case 0x45: EOR_Zero();break;
		case 0x46: LSR_Zero();break;
		case 0x48: PHA();break;
		case 0x49: EOR_Imm();break;
		case 0x4A: LSR_Acc();break;
		case 0x4C: JMP_Abs();break;
		case 0x4D: EOR_Abs();break;
		case 0x4E: LSR_Abs();break;
		case 0x50: BVC();break;
		case 0x51: EOR_Ind_Y();break;
		case 0x55: EOR_Zero_X();break;
		case 0x56: LSR_Zero_X();break;
		case 0x58: CLI();break;
		case 0x59: EOR_Abs_Y();break;
		case 0x5D: EOR_Abs_X();break;
		case 0x5E: LSR_Abs_X();break;
		case 0x60: RTS();break;
		case 0x61: ADC_IndX();break;
		case 0x65: ADC_Zero();break;
		case 0x66: ROR_Zero();break;
		case 0x68: PLA();break;
		case 0x69: ADC_Imm();break;
		case 0x6A: ROR_Acc();break;
		case 0x6C: JMP_Ind();break;
		case 0x6D: ADC_Abs();break;
		case 0x6E: ROR_Abs();break;
		case 0x70: BVS();break;
		case 0x71: ADC_Ind_Y();;break;
		case 0x75: ADC_Zero_X();break;
		case 0x76: ROR_Zero_X();break;
		case 0x78: SEI();break;
		case 0x79: ADC_Abs_Y();break;
		case 0x7D: ADC_Abs_X();break;
		case 0x7E: ROR_Abs_X();break;
		case 0x81: STA_IndX();break;
		case 0x84: STY_Zero();break;
		case 0x85: STA_Zero();break;
		case 0x86: STX_Zero();break;
		case 0x88: DEY();break;
		case 0x8A: TXA();break;
		case 0x8C: STY_Abs();break;
		case 0x8D: STA_Abs();break;
		case 0x8E: STX_Abs();break;
		case 0x90: BCC();break;
		case 0x91: STA_Ind_Y();break;
		case 0x94: STY_Zero_X();break;
		case 0x95: STA_Zero_X();break;
		case 0x96: STX_Zero_Y();break;
		case 0x98: TYA();break;
		case 0x99: STA_Abs_Y();break;
		case 0x9A: TXS();break;
		case 0x9D: STA_Abs_X();break;
		case 0xA0: LDY_Imm();break;
		case 0xA1: LDA_IndX();break;
		case 0xA2: LDX_Imm();break;
		case 0xA4: LDY_Zero();break;
		case 0xA5: LDA_Zero();break;
		case 0xA6: LDX_Zero();break;
		case 0xA8: TAY();break;
		case 0xA9: LDA_Imm();break;
		case 0xAA: TAX();break;
		case 0xAC: LDY_Abs();break;
		case 0xAD: LDA_Abs();break;
		case 0xAE: LDX_Abs();break;
		case 0xB0: BCS();break;
		case 0xB1: LDA_Ind_Y();break;
		case 0xB4: LDY_Zero_X();break;
		case 0xB5: LDA_Zero_X();break;
		case 0xB6: LDX_Zero_Y();break;
		case 0xB8: CLV();break;
		case 0xB9: LDA_Abs_Y();break;
		case 0xBA: TSX();break;
		case 0xBC: LDY_Abs_X();break;
		case 0xBD: LDA_Abs_X();break;
		case 0xBE: LDX_Abs_Y();break;
		case 0xC0: CPY_Imm();break;
		case 0xC1: CMP_IndX();break;
		case 0xC4: CPY_Zero();break;
		case 0xC5: CMP_Zero();break;
		case 0xC6: DEC_Zero();break;
		case 0xC8: INY();break;
		case 0xC9: CMP_Imm();break;
		case 0xCA: DEX();break;
		case 0xCC: CPY_Abs();break;
		case 0xCD: CMP_Abs();break;
		case 0xCE: DEC_Abs();break;
		case 0xD0: BNE();break;
		case 0xD1: CMP_Ind_Y();break;
		case 0xD5: CMP_Zero_X();break;
		case 0xD6: DEC_Zero_X();break;
		case 0xD8: CLD();break;
		case 0xD9: CMP_Abs_Y();break;
		case 0xDD: CMP_Abs_X();break;
		case 0xDE: DEC_Abs_X();break;
		case 0xE0: CPX_Imm();break;
		case 0xE1: SBC_IndX();break;
		case 0xE4: CPX_Zero();break;
		case 0xE5: SBC_Zero();break;
		case 0xE6: INC_Zero();break;
		case 0xE8: INX();break;
		case 0xE9: SBC_Imm();break;
		case 0xEA: NOP();break;
		case 0xEC: CPX_Abs();break;
		case 0xED: SBC_Abs();break;
		case 0xEE: INC_Abs();break;
		case 0xF0: BEQ();break;
		case 0xF1: SBC_Ind_Y();break;
		case 0xF5: SBC_Zero_X();break;
		case 0xF6: INC_Zero_X();break;
		case 0xF8: SED();break;
		case 0xF9: SBC_Abs_Y();break;
		case 0xFD: SBC_Abs_X();break;
		case 0xFE: INC_Abs_X();break;
		default: Quit("Unknown instruction");
		}/* end switch */
}/*end _6510 */

void VIC_II(void)
{
	unsigned char bgclr=color_map[RAMptr[0xD021]&15];
	short index;
	unsigned char temp;
#ifndef DOSVIDEO
	Xclrscr();
#endif
	for(index=0;index<999;index++)
	{
#ifdef DOSVIDEO
		vidram[index*2]=scrn_code[(temp=RAMptr[index+0x0400])&0x7F];
#else
		printf("%c",scrn_code[(temp=RAMptr[index+0x0400])&0x7F]);
		if (((index+1)%40)==0) printf("\n");
#endif
#ifdef DOSVIDEO
/* color */
		if(temp&0x80)
		{
		
	vidram[(index*2)+1]=((color_map[RAMptr[index+0xD800]]<<4)+bgclr)&0x7f;
		}
		else
		{
		
	vidram[(index*2)+1]=((bgclr<<4)+color_map[RAMptr[index+0xD800]&15])&0x7f;
		}
#endif
	}
}

short done;

void MainLoop(void)
{
	char key;
	short counter=0,counter2=0;
	done=0;
	while(done==0)
	{
		if(counter++==17476) /*17476*/
		{
			VIC_II();
			IRQ=1;
			counter=0;
		}/* end if time for VIC */
		if(counter2++==67)  /*67*/
		{
			RAMptr[0xD012]++;
			counter2=0;
		}/* end if time for raster */

		if (Xkbhit()) {
  		  key=Xgetch();
		  if(key==27) {done=1; return;}
        	  if ((key>96) && (key<124)) key-=32; /*Upcase*/
		  if (key==8) key=20; /* backspace => delete */
#ifdef UNIX		  
		  if (key==10) key=13; /* newline => return */
#endif		  
		  RAMptr[0x0277]=key;
		  RAMptr[0x00C6]=1;
		}
		/*Xgotoxy(1,1); printf("%c=%d   ",key,key);*/
		_6510();
		cycles++;
	}
}


void main()
{
	FILE *file;
	unsigned short index;
#ifdef UNIX
	term_init();
	term_character();
#endif
	/* Allocate memory */

	AllocMem();

	/* Load C64 ROMs into memory */

	LoadROM();

	/* Setup a few more things */

	curr_loc=(KernalPtr[0x1FFD]<<8)+KernalPtr[0x1FFC];
#ifdef DOSVIDEO
	SetMode(0x00);
#endif
	stack_ptr=0x1FF;
	modeset=1;
	/* Start main emulator loop */

	MainLoop();

	/* Cleanup */

	Cleanup();
#ifdef UNIX
	term_exit();
#endif

	Quit("Still in MAIN - ???");
}

